/***********************************************************************/
/* Copyright (c) 1999-2005, The Rector and Board of Visitors of the    */
/* University of Virginia.                                             */
/* All rights reserved.                                                */
/*                                                                     */
/* This program is being made available under the terms of version 2.1 */
/* of theGNU Lesser General Public License ("LGPL") as published as of */
/* February, 1999 by the Free Software  Foundation; and subject to the */
/* restrictions of the LGPL, you are authorized to  modify and/or      */
/* redistribute it.                                                    */
/*                                                                     */
/* As stated in the LGPL, THIS PROGRAM IS BEING MADE AVAILABLE "AS IS",*/
/* AND WITHOUT A WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,    */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF            */
/* MERCHANTABILITY AND  FITNESS FOR A PARTICULAR PURPOSE. FURTHER, YOU */
/* AGREE NOT TO HOLD THE COPYRIGHT  OWNER(S) LIABLE FOR DAMAGES,       */
/* INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,*/
/* ARISING OUT OF THE USE OR INABILITY TO USE  THE PROGRAM.            */
/* See the GNU General Public License for more details.                */
/*                                                                     */
/* You should have received a copy of version 2.1 of the GNU General   */
/* Public License along with this program; if not, you may obtain a    */
/* copy  from the Free Software Foundation website at the following URL*/
/* address (link  active as of September 1, 2005):                     */
/* http://www.fsf.org/licensing/licenses/lgpl.html; or that failing,   */
/* you can request a copy from Free Software Foundation,  Inc., 51     */
/* Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.                */
/*                                                                     */
/* This program is part of the HyperCast software distribution. To     */
/* learn more about HyperCast, please visit the website at             */
/* http://www.hypercast.org.                                           */
/***********************************************************************/

/** "Hello, world." program for HyperCast 2.0
 *
 * @author HyperCast Team 
 * @version Hello World (Callback Version) 1.0, Nov 2001
 */


import java.util.*;
import java.io.*;
import java.net.*;
import hypercast.*;
import hypercast.events.*;

public class HelloWorld implements I_ReceiveCallback
{ 

	public void ReceiveCallback(I_OverlayMessage RecvdMessage)
	{
	     /* get the logical address of the sender */ 
	     String SenderSrc = RecvdMessage.getSourceAddress().toString();
	
	     /* Next we transfor the received message into a string */
	     String sMsg=new String(RecvdMessage.getPayload(), 0, 
	     RecvdMessage.getPayloadLength());
	
	     /* ... and print the payload */ 
		 //if(!RecvdMessage.getSrcLogicalAddress().equals(MySocket.getLogicalAddress()))
		 System.out.println("Received <"+ sMsg + ">from node with logical address: " +SenderSrc +" . ");
	}


	public static void main(String[] args)
	{
	
		HelloWorld hw = new HelloWorld();
	
		NotificationHandler cnh = new myNotificationHandler ();
	
		String MyString = new String("Hello World");
	
		HyperCastConfig ConfObj = HyperCastConfig.createConfig("hypercast.xml");
	
		I_OverlaySocket MySocket=ConfObj.createOverlaySocket ((I_ReceiveCallback) hw, cnh);
	
		MySocket.joinOverlay();
	
		/*
		 * Application blocks here until event NODE_ISSTABLE occurs.
		 */
		cnh.waitUntil_NODE_ISSTABLE();
	
		System.out.println("This node's logical address is:" +MySocket.getLogicalAddress().toString());

		/*
		 * Send message to other applications.
		 */	
	    I_OverlayMessage MyMessage = MySocket.createMessage(MyString.getBytes());
	
	    MySocket.sendToAll(MyMessage);
	
	}

}

class myNotificationHandler extends NotificationHandler
{
	public void handle_NODE_ISSTABLE(NODE_ISSTABLE event)
	{
			System.out.println("event NODE_ISSTABLE has occured!");
	}
		
	public void handle_NODE_NEIGHBORHOODCHANGED(NODE_NEIGHBORHOODCHANGED event)
	{
		System.out.println("event NODE_NEIGHBORHOODCHANGED has occured!");
	}
}
