/***********************************************************************/
/* Copyright (c) 1999-2005, The Rector and Board of Visitors of the    */
/* University of Virginia.                                             */
/* All rights reserved.                                                */
/*                                                                     */
/* This program is being made available under the terms of version 2.1 */
/* of theGNU Lesser General Public License ("LGPL") as published as of */
/* February, 1999 by the Free Software  Foundation; and subject to the */
/* restrictions of the LGPL, you are authorized to  modify and/or      */
/* redistribute it.                                                    */
/*                                                                     */
/* As stated in the LGPL, THIS PROGRAM IS BEING MADE AVAILABLE "AS IS",*/
/* AND WITHOUT A WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,    */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF            */
/* MERCHANTABILITY AND  FITNESS FOR A PARTICULAR PURPOSE. FURTHER, YOU */
/* AGREE NOT TO HOLD THE COPYRIGHT  OWNER(S) LIABLE FOR DAMAGES,       */
/* INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,*/
/* ARISING OUT OF THE USE OR INABILITY TO USE  THE PROGRAM.            */
/* See the GNU General Public License for more details.                */
/*                                                                     */
/* You should have received a copy of version 2.1 of the GNU General   */
/* Public License along with this program; if not, you may obtain a    */
/* copy  from the Free Software Foundation website at the following URL*/
/* address (link  active as of September 1, 2005):                     */
/* http://www.fsf.org/licensing/licenses/lgpl.html; or that failing,   */
/* you can request a copy from Free Software Foundation,  Inc., 51     */
/* Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.                */
/*                                                                     */
/* This program is part of the HyperCast software distribution. To     */
/* learn more about HyperCast, please visit the website at             */
/* http://www.hypercast.org.                                           */
/***********************************************************************/

package hypercast;


/**
 * This is the interface for a finite state machine inside the message store
 *
 * @author HyperCast Team
 * @author Guimin Zhang * @version 2.0, May. 23, 2001 */


public abstract class I_MessageStoreFSM {
	
	/** debug flag */
	boolean debug = false;
	
	  
 /** check the change of the neighborhood   */	
  public abstract void changingNeighbor();	   
 /** Get the service number of the finite state machine   */
  public abstract short getFSMID();  
  /** set the new application message information*/
  public abstract void newADMsg(OL_Message msg);
  /** set the new control message information*/
  public abstract void newACMsg(OL_Message msg);  
  /** update the application message information  */
  public abstract void updateADMsg(OL_Message msg);
  /** update the control message information  */
  public abstract void updateACMsg(OL_Message msg);
    /** process the timer expired events   */
  public abstract void timerExpired(int timerIndex);
    public void timerExpired(Object object) { }

    /*
     * TODO: it is unclear whether or not the newA?Msg and updateA?Msg
     * method will remain in the system. Until a decision is made
     * these methods will be called by the message store so that calls
     * to newA?Msg and updateA?Msg do not appear in the main message
     * store code.
     */
    public final void receiveDataMessage (OL_Message message, boolean isNewMessage)
    {
        if (isNewMessage)
        {
            newADMsg (message);
        }
        else
        {
            updateADMsg (message);
        }
    }

    public final void receiveControlMessage (OL_Message message, boolean isNewMessage)
    {
        if (isNewMessage)
        {
			if (debug)
				System.out.println("I_MessageStoreFSM:receiveControlMessage: received new control Msg.");
				
            newACMsg (message);
        }
        else
        {
			if (debug)
				System.out.println("I_MessageStoreFSM:receiveControlMessage: received update control Msg.");
				
            updateACMsg (message);
        }
    }
}
