/***********************************************************************/
/* Copyright (c) 1999-2005, The Rector and Board of Visitors of the    */
/* University of Virginia.                                             */
/* All rights reserved.                                                */
/*                                                                     */
/* This program is being made available under the terms of version 2.1 */
/* of theGNU Lesser General Public License ("LGPL") as published as of */
/* February, 1999 by the Free Software  Foundation; and subject to the */
/* restrictions of the LGPL, you are authorized to  modify and/or      */
/* redistribute it.                                                    */
/*                                                                     */
/* As stated in the LGPL, THIS PROGRAM IS BEING MADE AVAILABLE "AS IS",*/
/* AND WITHOUT A WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED,    */
/* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF            */
/* MERCHANTABILITY AND  FITNESS FOR A PARTICULAR PURPOSE. FURTHER, YOU */
/* AGREE NOT TO HOLD THE COPYRIGHT  OWNER(S) LIABLE FOR DAMAGES,       */
/* INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES,*/
/* ARISING OUT OF THE USE OR INABILITY TO USE  THE PROGRAM.            */
/* See the GNU General Public License for more details.                */
/*                                                                     */
/* You should have received a copy of version 2.1 of the GNU General   */
/* Public License along with this program; if not, you may obtain a    */
/* copy  from the Free Software Foundation website at the following URL*/
/* address (link  active as of September 1, 2005):                     */
/* http://www.fsf.org/licensing/licenses/lgpl.html; or that failing,   */
/* you can request a copy from Free Software Foundation,  Inc., 51     */
/* Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.                */
/*                                                                     */
/* This program is part of the HyperCast software distribution. To     */
/* learn more about HyperCast, please visit the website at             */
/* http://www.hypercast.org.                                           */
/***********************************************************************/

package hypercast;


/**
 * This class impements a timer ID used by the socket adapter.
 *
 * @author HyperCast Team
 * @author Jianping Wang
 * @version 3.0, Dec. 05, 2003
 */

public class Socket_Timer_ID{
    /**the type indicating the object using the timer. */
    private int type;
    /** event of the timeout. */
    private Object event;
    /**define the type vlue used by the MessageStore */
    public final static int typeOfMessageStore = 0;
	/**define the type vlue used by the StreamManager */
	public final static int typeOfStreamManager = 1;
	
	/** Constructor.
	 * @param	t  	the type indicating the object using the timer.
	 * @param   o	index value of the protocol node.
	 */
	public Socket_Timer_ID(int t, Object o) {
		type = t;
		event =o;
	}


	/** Constructor.
	 * Constructs a new Socket_Timer_ID object from another 
	 * Socket_Timer_ID object.
	 * @param	te	a Socket_Timer_ID object
	 */
	public Socket_Timer_ID(Socket_Timer_ID te) {
		type = te.getType();
		event = te.getEvent();
	}

	/**
	 * Returns the type  
	 */
	public int getType() {
		return type;
	}

	
	/**
	 * Returns the event object
	 */
	public Object getEvent() {
		return event;
	}
	
	/**
	 * compare two Socket_Timer_IDs.
	 * Returns true if they are equal, and false otherwise.
	 */
	public boolean equals(Object o)  {
        	if (o == null)  
            	return false;
        
        	if (!(o instanceof Socket_Timer_ID))
        	    throw new IllegalArgumentException("Socket_Timer_ID.equals() pass a object that was not a _MultiPro_Timer_ID!");
        
        	Socket_Timer_ID td = (Socket_Timer_ID) o;
        	return type == td.getType() && event.equals(td.getEvent());
    	}
}
